/*
 * LOGON.C (A QUANTUM HACK)
 *
 *  V1.0 12/19/89
 *  V2.0 12/19/90
 *
 * General Pupose logon event program for BBS's or other systems.
 * Refer to separte manual page (logon.1/logon.doc)
 *
 *  usage: logon [path]
 *
 * Please send enhancements to data files, new fortunes, daily trivia
 * ANSI pictures to:
 * |------------------------------||-------------------------------|
 * |      Andrew  W. Gaunt        ||         ==Info=Rail==         |
 * |------------------------------||  ___.___    ______ ____    __ |
 * |Internet: awg@attsb.att.com   || _|@ @ @|_   |----|  | 0|___||.|
 * |uucp:  ... att!attsb!awg      ||:| ----- |:__||  ||__| _| : : }|
 * |WWIVnet: 3@6300 2@6301 1@5804 || -(0)--(0)-  0----0  -(O)-==-o\|
 * |BBS: Quantum on ==Info=Rail== ||==24=Hours===========3/12/2400=|
 * |        NH (603)382-3966      ||WWIVnet @6300  NH (603)382-3966|
 * |------------------------------||-------------------------------|
 *
 * I would like to keep a master file and make it available to everyone.
 *
 * With alot of people adding input to these data files this could be
 * a real neat package. With 365 days a year, there shouldn't be much
 * of a problem finding days to celebrate with ANSI pictures or
 * commerating with trivia/historical facts.
 *
 *************** Program History ********************
 * Most recent changes shown first
 ******** ******** ******** ******** ******** *******
 *
 *** 12/31/90 * Slight changes to V2.0, V2.0a is now pending ..
 *
 * Put the bulletin prompt in a file rather than having it hard coded.
 * More like the Picture of the XXX prompts.
 * 
 * Lengthened the time for MAXWAIT to 60 seconds
 *
 * Reworded some error messages.
 *
 * Intend to include compiled version of TOPTEN.C in next dist. archive
 *
 *** 12/19/90 * Version 2.0 Ready to be archived
 *
 *** 12/11/90 * Major revisions:
 * I got a copy of "cookie.c" a public domain version of a random
 * fortune cookie printer. The code to pick them used and indexed
 * table to find them faster. A separate program called cookhash
 * had to be run to build the table. I used the both of these programs
 * to provide the workhorse for the "fortune cookie" feature. The hash
 * table rebuilder has been integrated with the main program, it now 
 * checks the modification times on the "cookie" file, fortunes.txt and
 * it's index, "fortunes.dat". If the cookie file is newer the index table
 * is rebuilt. 
 * Alot of new cookies were added too.
 *
 * Cookie Credits to:
 * *** cookie - print out an entry from the sayings file
 * *** by Karl Lehenbauer (karl@sugar.uu.net, uunet!sugar!karl)
 * *** cookie.c  1.1  1/12/89
 * It took some considerable hacking to get it to work properly when
 * compiled with Turbo-C, I didn't realize I had to open the cookie files
 * with the "b"inary mode. This baffled me for some time!
 *
 *** 12/10/90
 * An option to allow screen pausing was added. Because this has been
 * written with WWIV in mind, the 'P' key pauses the screen. It can easily
 * be changed to something else [ see mykbhit() ].
 *
 *** 12/10/90
 * Some of the code was made more efficient.
 *
 *
 *** 02/23/90 Add topten.hdr/msg/tlr support. For list
 *          of Topten Downloads
 *
 *** 02/22/90 Add trailers and split MOTD up so that
 *         Months may be in different files
 *         Ported a bunch of data from TODAY PC
 *
 *** 01/31/90 * Using Turbo-C functions getch and kbhit at picture prompts.
 *** 12/28/89 * Added Ansi picture of month & day.
 *
 *** 12/19/89 * BIRTH
 *
 */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <stdlib.h>
#include <process.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#define YES 1
#define NO 0
#define MAXLINE 512
#define MAXDIR 512
#define ENTSIZE 7L
#define METACHAR '%'
#define WAITTIME 60L /* Max of WAITTIME seconds to pause on a bulletin */
#define PAUSEWARN 10L /* Warn user if paused more than PAUSEWARN secs */
extern long lseek(), time();
extern int rand();

char line[500];
char bline[500];

/*  I'm using Turbo-C's random stuff - I'll leave this anyway */
/* really_random - insure a good random return for a range, unlike an
 * arbitrary random() % n, thanks to Ken Arnold, Unix Review, October 1987
 * ...likely needs a little hacking to run under Berkely
 */
/*
#define RANDOM_RANGE ((1 << 15) - 1)
int really_random(my_range)
int my_range;
{
	int max_multiple, rnum;
	max_multiple = RANDOM_RANGE / my_range;
	max_multiple *= my_range;
	while ((rnum = rand()) >= max_multiple)
		continue;
	return(rnum % my_range);
}
*/

main(argc,argv)
int argc;
char *argv[];
{

	FILE *fp;
	char c;
	char month[10];
	char day[10];
	long i,j; /* for timeouts */
	int q;

	char directory[MAXDIR]; /* directory where below are located */
	/* headers */
	char notice_hdr[MAXDIR+9]; /* mandatory read file */
	char hear_ye_hdr[MAXDIR+9]; /* optional announcement file */
	char bull_hdr[MAXDIR+9]; /* bulletin menu */
	char fortunes_hdr[MAXDIR+9]; /* fortune file */
	char motd_hdr[MAXDIR+9]; /* message of the day */
	char topten_hdr[MAXDIR+9]; /* top ten downloads */
	/* trailers */
	char notice_tlr[MAXDIR+9]; /* mandatory read file */
	char hear_ye_tlr[MAXDIR+9]; /* announcement file */
	char bull_tlr[MAXDIR+9]; /* bulletin menu */
	char fortunes_tlr[MAXDIR+9]; /* fortune file */
	char motd_tlr[MAXDIR+9]; /* message of the day */
	char topten_tlr[MAXDIR+9]; /* top ten downloads */
	/* data files */
	char notice[MAXDIR+9]; /* mandatory read file */
	char hear_ye[MAXDIR+9]; /* announcement file */
	char bull[MAXDIR+9]; /* bulletin menu */
	char fortunes[MAXDIR+9]; /* fortune file */
	char hashfile[MAXDIR+9]; /* hashfile for fortunes */
	char motd[MAXDIR+9]; /* message of the day */
	char topten[MAXDIR+9]; /* top ten downloads */
	char potm[MAXDIR+9]; /* picture of the month */
	char potd[MAXDIR+9]; /* picture of the day */
	char bullp[MAXDIR+9]; /* bulletin prompt */
	char potmp[MAXDIR+9]; /* picture of the month prompt */
	char potdp[MAXDIR+9]; /* picture of the day prompt */

	char s1[MAXDIR]; /* temp */
	char s2[MAXDIR]; /* temp */

 	strcpy(directory,"");
	if (argc > 1) {
		if ( strlen(argv[1]) >MAXDIR-1 ){
			printf("logon: argument too long");
			exit(1);
		}
		strcat(directory,argv[1]);
	}

	sprintf(notice_hdr,"%s%s",directory,"notice.hdr");
	sprintf(hear_ye_hdr,"%s%s",directory,"hear_ye.hdr");
	sprintf(bull_hdr,"%s%s",directory,"bull.hdr");
	sprintf(fortunes_hdr,"%s%s",directory,"fortunes.hdr");
 	sprintf(motd_hdr,"%s%s",directory,"motd.hdr");
 	sprintf(topten_hdr,"%s%s",directory,"topten.hdr");
	sprintf(notice_tlr,"%s%s",directory,"notice.tlr");
	sprintf(hear_ye_tlr,"%s%s",directory,"hear_ye.tlr");
	sprintf(bull_tlr,"%s%s",directory,"bull.tlr");
	sprintf(fortunes_tlr,"%s%s",directory,"fortunes.tlr");
	sprintf(motd_tlr,"%s%s",directory,"motd.tlr");
 	sprintf(topten_tlr,"%s%s",directory,"topten.tlr");
	sprintf(notice,"%s%s",directory,"notice.msg");
	sprintf(hear_ye,"%s%s",directory,"hear_ye.msg");
	sprintf(bull,"%s%s",directory,"bull.msg");
	sprintf(fortunes,"%s%s",directory,"fortunes.txt");
	sprintf(hashfile,"%s%s",directory,"fortunes.dat");
	sprintf(motd,"%s",directory);
 	sprintf(topten,"%s%s",directory,"topten.msg");
	sprintf(potm,"%s",directory);
	sprintf(potd,"%s",directory);
	sprintf(bullp,"%s%s",directory,"bull2.msg");
	sprintf(potmp,"%s%s",directory,"potm.msg");
	sprintf(potdp,"%s%s",directory,"potd.msg");


	/* Current Notice - reading mandatory */
	type(notice_hdr,1);
 	type(notice,1);
	type(notice_tlr,1);

	/* Current Announcements - reading is optional */
	type(hear_ye_hdr,0);
 	type(hear_ye,0);
	type(hear_ye_tlr,0);


/* 	printf("\ndir=[%s]\n",directory); */
	/* Current Bulletins - Optional */
	type(bull_hdr,0);
	if (type(bull,0)){
		printf("<< There are no Bulletins to read. >>\n");
	}
	else{
		q=0;
		do{
			type(bullp);
			time(&i);
			purgkey();
			while (!kbhit()) {
				time(&j);
				if(j>i+WAITTIME/2){
					if (q==0){
						printf("\007");
					}
					q++;
					if (q>1){
						printf("[Quit]\n");
					}
					break;
				}
			}
			if (kbhit()){
				c=getch();
				switch (c) {
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
						printf("%c.\n",c);
						sprintf(s1,"%s%s%c",directory,"bull.",c);
						break;

					case ' ':
					case 'Q':
					case 'q':
						printf("Quit\n");
						q=9;
						sprintf(s1,"");
						break;

					case '?':
						printf("List\n");
						type(bull,0);

					default:
						sprintf(s1,"");
						break;
				}
				if (strcmp(s1,"") != NULL){
					if ( (fp=fopen(s1,"r")) != NULL){
						fgets(s2,MAXDIR,fp);
						fclose(fp);
					}
					else{
						continue;
					}
					if(!type(s2,0)){
						printf("[PAUSED]\b\b\b\b\b\b\b\b");
						time(&i);
						purgkey();
						while (!kbhit()) {
							time(&j);
							if(j>i+WAITTIME/2){
								printf("[PAUSED]\b\b\b\b\b\b\b\b");
							}
							if(j>i+WAITTIME){
								break;
							}
						}
						type(bull,0);
					}
					continue;
				}
			}
		}while(q<2);
	}
	type(bull_tlr,0);

	/* Top Ten Downloads */
	type(topten_hdr,0);
 	type(topten,0);
	type(topten_tlr,0);

	/* Random fortune or proverb */
	rehash(fortunes,hashfile);
	type(fortunes_hdr,0);
	fortune(fortunes,hashfile);
	type(fortunes_tlr,0);

	/* Message of the day */
	/* motd_00.txt */
/* 	printf("%smotd_00.txt\n",motd); */
	sprintf(s1,"%smotd_00.txt",motd);
	onthisday(s1,month,day,motd_hdr);
	/* motd_MM.txt */
/* 	printf("%smotd_%s.txt\n",motd,month); */
	sprintf(s1,"%smotd_%s.txt",motd,month);
	onthisday(s1,month,day,motd_hdr);
	type(motd_tlr,0);

	/* Picture of the Month, Ansi or Regular text */
 	strcat(potm,month);
 	strcat(potm,"00");
	strcat(potm,".ans");

	if ((fp=fopen(potm, "r")) != NULL ){
		fclose(fp);
		while (1) {
			type(potmp,0);
			switch (yn()){

				case NULL:            /* Invalid Answer */
					continue;
				case 1:               /* Yes */
					type(potm,0);
					break;
				case -1:              /* No */
					break;
			}
			break;
		}
	}



	/* Picture of the day, Ansi or Regular text */
 	strcat(potd,month);
 	strcat(potd,day);
	strcat(potd,".ans");

	if ((fp=fopen(potd, "r")) != NULL ){
		fclose(fp);
		while (1) {
			type(potdp,0);
			switch (yn()){

				case NULL:
					continue;
				case 1:
					type(potd,0);
					break;
				case -1:
					break;
			}
			break;
		}
	}
}

fortune(cookiename,hashname)
char *cookiename[], *hashname[];
{
	int nentries,oneiwant, c, sawmeta = 0;
	FILE *hashf, *cookief;
	long cookiepos;

	/* if we got exactly three arguments, use the cookie and hash
	 * files specified
	 */

	/* open the cookie file for read */
	if ((cookief = fopen(cookiename,"rb")) == NULL)
	{
		perror(cookiename);
		exit(2);
	}

	/* open the hash file for read */
	if ((hashf = fopen(hashname,"rb")) == NULL)
	{
		perror(hashname);
		exit(2);
	}

	/* compute number of cookie addresses in the hash file by
	 * dividing the file length by the size of a cookie address
	 */
 	if (fseek(hashf,0L,2) != NULL)
	{
		perror(hashname);
		exit(3);
	}
 	nentries = (long) ftell(hashf) / ENTSIZE;
/* 	printf("nentries=%d\n",nentries); */

/* I'm using Turbo-C's random stuff, I'll leave this in anyway */
	/* seed the random number generator with time in seconds plus
	 * the program's process ID - it yields a pretty good seed
	 * again, thanks to Ken Arnold
	 */
/* 	srand(getpid() + time(NULL)); */
/* 	srand(time(NULL)); */
	randomize();

	/* generate a not really random number */
/* 	oneiwant = really_random(nentries); */
	oneiwant = random(nentries);
/* 	printf("oneiwant=%d\n",oneiwant); */

	/* locate the one I want in the hash file and read the
	 * address found there
	 */
/* 	fseek(hashf, oneiwant * ENTSIZE, 0); */
	fseek(hashf, oneiwant * ENTSIZE, 0);
	fscanf(hashf,"%lx",&cookiepos);
/* 	printf("cookiepos=%lx\n",cookiepos); */

	/* seek cookie file to cookie starting at address read from hash */
	fseek(cookief,cookiepos,0);

	/* get characters from the cookie file and write them out
	 * until finding the end-of-fortune sequence, '%%'
	 */
	while ((c = fgetc(cookief)) != EOF && sawmeta < 2 )
	{
		if (c != METACHAR)
		{
			if (sawmeta)
				putchar(METACHAR);
			putchar(c);
			sawmeta = 0;
		}
		else
			sawmeta++;
	}
	fclose(hashf);
	fclose(cookief);
}


onthisday(f,m,d,h)
char *f;
char m[];
char d[];
char h[];
{

	FILE *fp;
	int month,day;
	short flag;
	char line[MAXLINE];
	char today[10];
	long T;
	struct tm *tp;

	if ((fp = fopen(f, "r")) == NULL ){
		return(1);
	}

	T = time( (long *)0 );
	tp = localtime(&T);
	month=tp->tm_mon+1;
	day=tp->tm_mday;
	sprintf(m,"%02d",month);
	sprintf(d,"%02d",day);

  	sprintf(today,"%02d:%02d\n",month,day);
	flag=0;
	while ( (fgets(line,MAXLINE,fp) !=NULL) && (!mykbhit()) ) {

		if ( strcmp(line,today) == NULL) {
			type(h,0);			
			flag=1;
			continue;
		}

		if ( strcmp(line,"/*\n") == NULL) {
			continue;
		}

		if ( strcmp(line,"*/\n") == NULL) {
			flag=0;
		}

		if ( flag == 1) {
			printf("%s",line);
		}
	}
	purgkey();
	fclose(fp);
	return(0);
}

type(f,i)
char *f;
int i;
{
	int c;
	FILE *fp;

	if ((fp = fopen(f, "r")) == NULL) {
		return(1);
	}
	else {
		/* type out until eof or key is hit */
		while ( (c=fgetc(fp)) != EOF ) {
			fputc(c,stdout);
			if ( (i==0) && mykbhit()){
				break;
			} 
		}
		purgkey();
		fclose(fp);
	}
	return(0);
}

purgkey()
{
	/* clear out buffer if key(s) has been hit*/
	/* and place cursor at start of line */
	if (kbhit()){
		putchar('\n');
	}
	while(kbhit()) {
		getch();
	}

}
			
yn()
{
	long i,j; /* timeouts */
	int c;
	while(1){
		time(&i);
		purgkey();
		while (!kbhit()) {
			time(&j);
			if(j>i+WAITTIME){
				printf("[No]\n");
				return(-1);
			}
		}
		c=getch();
		switch (tolower(c)) {
			case 'y':
				printf("Yes\n");
				return(1);
			case 'n':
			case ' ':
				printf("No\n");
				return(-1);
			default:
				return(0);
		}
	}
}

mykbhit()
{
	long i,j;
	int c;
	static short pause;

	if(kbhit()){
		c=getch();
		switch (tolower(c)) {
			case 'p':
				if (pause==0){
					pause=1;
					time(&i);
					while (!kbhit()){
						time(&j);
						/* Warn user if paused more than 10 seconds */
						if (j>i+PAUSEWARN){
							printf("\007[PAUSED]\b\b\b\b\b\b\b\b");
							time(&i);
						}
					}
				}
				else{
					pause=0;
				}
				return(0);

			case '\n':
			case ' ':
				if (pause==0)
					return(1);
			default:
				return(1);
		}
	}
}


rehash(fortunes,hashfile)
char *fortunes[];
char *hashfile[];
{
	int c, sawmeta;
	long charpos = 0;
	struct stat fist;
	struct stat fost;
	FILE *fi,*fo;


	if (stat(fortunes,&fist) != NULL){
		perror("logon: rehash: error in stat for input file.");
		exit(2);
	}
	if (stat(hashfile,&fost) != NULL){
		perror("logon: rehash: error in stat for output file.");
		exit(2);
	}


/* Compare modification times of fortunes.txt and fortunes.dat
 * If fortunes newer then rebuild the fortunes.dat
 */
	if (fist.st_atime < fost.st_atime){
		return(0);
	}

	if ( (fi=fopen(fortunes,"rb")) == NULL){
		perror(fortunes);
		exit(2);
	}
	if ( (fo=fopen(hashfile,"wb")) == NULL){
		perror(hashfile);
		exit(2);
	}

	printf("\n<< Please standby, rebuilding hash table ... >>\n");

	/* write out the "address" of the first cookie */
	fprintf(fo,"000000\n");

	/* read the cookie until the end,
	 *   whenever the end-of-cookie ("%%") sequence is found,
	 *   the "address" (file position) of the first byte following
	 *   it (start of next cookie) is written to the index (hash) file
	 */
	sawmeta=0;
	while ((c = getc(fi)) != EOF)
	{
		if (c == METACHAR)
		{
			if (sawmeta)
			{
				fprintf(fo,"%06lx\n",charpos+2);
				printf(".");
				sawmeta = NO;
			}
			else
				sawmeta = YES;
		}
		else
			sawmeta = NO;
		charpos++;
	}
	fclose(fi);
	fclose(fo);
 	printf("< %s %ld Bytes >\n",fortunes,fist.st_size);
	printf("< %s %ld Bytes >\n",hashfile,fost.st_size);
	return(1);
}

